<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

class c_bookingPurpose{
	var $bookingPurposeK;
	var $description;
	var $modified_by;
	var $modified_date;
	var $showInList;
	
	function loadById($id){
		$sql = 'SELECT * FROM tblBookingPurpose WHERE bookingPurposeK='.$this->bookingPurposeK;
		
		if(!$res = dbQuery($sql)){
			debug(dbError($sql));
		}else{
			if(!$row = dbFetchAssoc($res)){
				debug(dbError($sql));
			}else{
				$this->bookingPurposeK = $row['bookingPurposeK'];
				$this->description = $row['description'];
				$this->modified_by = $row['modified_by'];
				$this->modified_date = $row['modified_date'];
				$this->showInList = $row['showInList'];
				
				
				dbFreeResult($res);
			}
		}
	}
	
	function loadPosted(){
		global $p;
		
		$this->bookingPurposeK = (isset($p->bookingPurposeK)?$p->bookingPurposeK:0);
		$this->description = (isset($p->description)?$p->description:'');
		$this->modified_by = (isset($p->modified_by)?$p->modified_by:0);
		$this->modified_date = (isset($p->modified_date)?$p->modified_date:0);
		$this->showInList = (isset($p->showInList)?$p->showInList:false);
		
	}
	
	function insertNew(){
		$sql = 'INSERT INTO tblBookingPurpose(description, modified_by, modified_date, showInList) VALUES ("'.dbEscapeString($this->description).'",'.$this->modified_by.',"'.$this->modified_date.'",'.$this->showInList.');';
		if(!dbQuery($sql)){
			debug(dbError($sql));
			$newId = false;
		}else{
			$newId = dbInsertId();
		}
		
		return $newId;
	}
	
	function validate(){
		global $invalidFields;	
	
		if(isset($this->bookingK)){
			//validating an update
			if(!isnumeric($this->bookingPurposeK)){
				$invalid['bookingPurposeK'] = 'Please supply a Booking Purpose';
			}
		}
		
		if(strlen(trim($this->description))<1){
			$invalid['description'] = 'Please supply a description for the Booking Purpose';
		}
		
		if(count($invalid) > 0) {
        $invalidFields = array_merge($invalidFields, $invalid);
        return false;
      }
      return true;
		
	}
	
	function reset(){
		$this->bookingPurposeK = 0;
		$this->description = '';
		$this->modified_by = 0;
		$thiis->modified_date = '';
		$this->showInList = false;
	}
}

class c_booking{
	var $bookingK;
	var $departmentFK;
	var $vehicleFK;
	var $bookingPurposeFK;
	var $employeeFK;
	var $booking_start;
	var $booking_end;
	var $reminder_hours;
	var $destination;
	var $numOccupants;
	var $siteFK;
	var $booking_start_time;
	var $booking_end_time;
	var $bookingPurpose;
	var $CostCentreFK;
	
	 function c_booking($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
	
	function loadById($id){
		global $invalidFields;
		$this->bookingK = $id;
		if((!isset($this->bookingK))){
			$invalidFields['bookingK'] = 'No Booking Id Supplied';
		}
		
		$sql = 'SELECT * FROM tblBooking WHERE bookingK='.$this->bookingK;
		
		if(!$res = dbQuery($sql)){
			debug(dbError($sql));
		}else{
			if(!$row = dbFetchAssoc($res)){
				$invalidFields['bookingK'] = 'The Selected Booking Could not be Found';
			}else{
				
				
				array_map_to_this($row, $this);
				
				dbFreeResult($res);
			}
		}
		
	}
	
	function loadPosted(){
		global $p;

		$this->bookingK = (isset($p->bookingK) ? $p->bookingK : 0);
		$this->departmentFK=(isset($p->departmentFK) ? $p->departmentFK : (isset($this->departmentFK) ? $this->departmentFK : 0));
		//$this->vehicleFK=(isset($p->vehicleFK) ? $p->vehicleFK : 0);
		$this->vehicleFK=(isset($p->vehicleFK) ? $p->vehicleFK : (isset($this->vehicleFK) ? $this->vehicleFK : 0));
		$this->bookingPurposeFK=(isset($p->bookingPurposeFK) ? $p->bookingPurposeFK : 0);
		$this->employeeFK=(isset($p->employeeFK) ? $p->employeeFK : (isset($this->employeeFK) ? $this->employeeFK : 0));
		$this->booking_start=(isset($p->booking_start) ? $p->booking_start : (isset($this->booking_start) ? $this->booking_start : false));
		$this->booking_end=(isset($p->booking_end) ? $p->booking_end : (isset($this->booking_end) ? $this->booking_end : false));
		$this->reminder_hours=(isset($p->reminder_hours) ? $p->reminder_hours : (isset($this->reminder_hours) ? $this->reminder_hours : 0));
		$this->destination=(isset($p->destination) ? $p->destination : (isset($this->destination) ? $this->destination : ''));
		$this->numOccupants = (isset($p->numOccupants) ? $p->numOccupants : (isset($this->numOccupants) ? $this->numOccupants : 0));
		$this->siteFK = (isset($p->siteFK) ? $p->siteFK : (isset($this->siteFK) ? $this->siteFK : 0));
		$this->booking_start_time = (isset($p->booking_start_time) ? $p->booking_start_time : (isset($this->booking_start_time) ? $this->booking_start_time : ''));
		$this->booking_end_time = (isset($p->booking_end_time) ? $p->booking_end_time : (isset($this->booking_end_time) ? $this->booking_end_time : ''));
		$this->bookingPurpose=(isset($p->bookingPurpose) ? $p->bookingPurpose : '');
		$this->CostCentreFK=(isset($p->CostCentreFK) ? $p->CostCentreFK : 0);
		
		if($this->destination==-2){
			$this->destination = (isset($p->bookingDestinationText) ? $p->bookingDestinationText : (isset($this->bookingDestinationText) ? $this->bookingDestinationText : ''));
		}
		
		if($this->bookingPurposeFK==-2){
			//insert a new bookinig purpose FK
			$bookingPurpose = new c_bookingPurpose();
			
			$bookingPurpose->description = (isset($p->bookingPurposeText)?$p->bookingPurposeText:'');
			$bookingPurpose->modified_by = $this->employeeFK;
			$bookingPurpose->modified_date = date('Y-m-d H:i:s', strtotime("now"));
			$bookingPurpose->showInList = 1;
			
			$newPurposeId = $bookingPurpose->insertNew();
			//assign the newly created id as the purpose FK
			
			$this->bookingPurposeFK =$newPurposeId;
			
		}
	}
	
	function validate(){
		global $invalidFields;
		
		$invalid = array();
		
		//check to ensure a department has been supplied
		if((!isset($this->departmentFK)) || (!isnumeric($this->depertmentFK)) || ($this->departmentFK <1)){
			$invalid['departmentFK'] = 'Please supply a valid Department';
		}else{
			//make sure the supplied department exists
			$sql = 'SELECT COUNT(*) as lCount FROM tblDepartment WHERE departmentK='.$this->departmentFK;
			$res = dbQuery($sql);
			if(!$res){
				debug(dbError($sql));
			}else{
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount'] < 1){
						$invalid['departmentFK'] = 'The Selected Department Could not be Found';
					}
				}
			}
		}
		
		//make sure the vehicle has been supplied
		if((!isset($this->vehicleFK)) || (!isnumeric($this->vehicleFK)) || ($this->vehicleFK < 1)){
			$invalid['vehicleFK'] = 'Please Select a Vehicle';
		}else{
			//make sure the supplied department exists
			$sql = 'SELECT COUNT(*) as lCount FROM tblVehicle WHERE VehicleK='.$this->vehicleFK;
			$res = dbQuery($sql);
			if(!$res){
				debug(dbError($sql));
			}else{
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount'] < 1){
						$invalid['vehicleFK'] = 'The Selected Vehicle Could not be Found';
					}
				}
			}
		}		
		
		//make sure the Booking Purpose has been supplied
		/*if((!isset($this->bookingPurposeFK)) || (!isnumeric($this->bookingPurposeFK)) || ($this->bookingPurposeFK < 1)){ */
		if((!isset($this->bookingPurpose)) || ($this->bookingPurpose=='')){
			$invalid['vehicleFK'] = 'Please enter a Booking Purpose';
		}
		/*
		else{
			//make sure the supplied department exists
			$sql = 'SELECT COUNT(*) as lCount FROM tblBookingPurpose WHERE bookingPurposeK='.$this->bookingPurposeFK;
			$res = dbQuery($sql);
			if(!$res){
				debug(dbError($sql));
			}else{
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount'] < 1){
						$invalid['bookingPurposeFK'] = 'The Selected Booking Purpose Could not be Found';
					}
				}
			}
		}	
		*/
		
		//make sure the Employee has been supplied
		if((!isset($this->employeeFK)) || (!isnumeric($this->employeeFK)) || ($this->employeeFK < 1)){
			$invalid['employeeFK'] = 'Please Select an Employee';
		}else{
			//make sure the supplied department exists
			$sql = 'SELECT COUNT(*) as lCount FROM tblEmployee WHERE employeeK='.$this->employeeFK;
			$res = dbQuery($sql);
			if(!$res){
				debug(dbError($sql));
			}else{
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount'] < 1){
						$invalid['employeeFK'] = 'The Selected Employee Could not be Found';
					}
				}
			}
		}		
		
		if($this->CostCentreFK == 0) {
	        $invalid['CostCentreFK'] = "Please select a Cost Centre for this Booking";
	      }
		
		//make sure a valid Booking start date and time has been supplied
		if(!isset($this->booking_start)){
			$invalid['booking_start'] = 'Please enter a Valid Booking Start Date and Time';
		}else{
			//ensure the date that was supplied is a valid date for a booking
			
		}
		//make sure a valid booking end date and time has been supplied
		
		//make sure a reminder hours value has been set
		if((strlen(trim($this->reminder_hours)) <1) || (!isnumeric($this->reminder_hours))){
			$invalid['reminder_hours'] = 'Please enter a valid Reminder Hours Entry';
		}
		
		//make sure a destination value has been set
		if(strlen(trim($this->destination))<1){
			$invalid['destination'] = 'Please enter a destination';
		}else{
			if(strlen(trim($this->destination))>100){
				$invalid['destination'] = 'The Destination must be 100 Characters or less in length';
			}
		}
		
		//make sure the number of travellers have been supplied
		if((strlen(trim($this->numOccupants))<1) || $this->numOccupants < 1){
			$invalid['numOccupants'] = 'Please enter the Number of Expected Occupants of the Vehicle'; 
		}
		
		//make sure a departure site has been supplied
		if((strlen(trim($this->siteFK))<1) || $this->siteFK<1){
			$invalid['siteFK'] = 'Please select a Departure Location';
		}
		
		if(count($invalid) > 0) {
        $invalidFields = array_merge($invalidFields, $invalid);
        return false;
      }
      return true;
	}
	
	function reset(){
		$this->bookingK=0;
		$this->departmentFK=0;
		$this->vehicleFK=0;
		$this->bookingPurposeFK=0;
		$this->employeeFK=0;
		$this->booking_start='';
		$this->booking_end='';
		$this->reminder_hours=0;
		$this->destination='';
		$this->numOccupants = 0;
		$this->bookingPurpose="";
		$this->CostCentreFK=0;
	}
}

?>