<?php

/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

  /** ==========================================================================
  ** Script Name 	: Our Fleet - Damages Class
  ** Creation Date : Sept 7 2006
  ** Author				: Daniel
  ** Author Email	: 
  */
  
  class cDamage {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
  		var $damageK;
		var $vehicleFK;
		var $employeeFK;
		var $description;
		var $reference;
		var $damagedate;
		var $modified_date;
		var $modified_by; 

    function cDamage($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblDamage WHERE tblDamage.damageK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);
		  $row['damagedate'] = substr($row['damagedate'],0,10);

          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    
    
    	//load the class variables from the posted values
    	$this->damageK = (isset($p->damageK) ? $p->damageK : '');
		$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '');
		$this->employeeFK = (isset($p->employeeFK) ? $p->employeeFK : '');
		$this->description = (isset($p->description) ? $p->description : '');
		$this->reference = (isset($p->reference) ? $p->reference : '');
		$this->damagedate = (isset($p->damagedate) ? $p->damagedate : '');
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
      
     	$acc_Time_hours =(isset($p->time_date_hours) ? $p->time_date_hours : '');
      $acc_Time_minutes =(isset($p->time_date_minutes) ? $p->time_date_minutes : '');
      $acc_Time_ap =(isset($p->time_date_ap) ? $p->time_date_ap : '');
      
      $this->damagedate = $this->damagedate.' '.$acc_Time_hours.':'.$acc_Time_minutes.':00 '.$acc_Time_ap;
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		if($this->damageK != 0){
			$sql = 'SELECT COUNT(*) as lCount FROM tblDamage WHERE damageK='. dbEscapeString($this->damageK);
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount']==0){
						$invalid['damageK'] = 'The Selected Damage could not be found';
					}
				}
				dbFreeResult($res);
			}
		}  

		if($this->vehicleFK == 0){
			$invalid['vehicleFK'] = 'Please enter a valid Vehicle ID';
		}
		
		if($this->employeeFK == 0){
			$invalid['employeeFK'] = 'Please select an Employee';
		}
		if(strlen($this->reference) > 60) {
			$invalid['reference'] = "Reference Number exeeds the maximum field length";
		}
		
		if(strlen(trim($this->description)) == ''){
			$invalid['description'] = 'Please enter a Description';
		} else{
			if(strlen(trim($this->description))>200){
				$invalid['description'] = 'The Description can be no longer than 200 characters in length';
			}
		}


		if(strlen(trim($this->damagedate)) == 0){
			$invalid['damagedate'] = 'Please select a Date';
		}   

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->damageK = 0;
      $this->vehicleFK = 0;
      $this->employeeFK = 0;
      $this->description = '';
      $this->reference = '';
      $this->damagedate = '';
      $this->modified_date = '';
      $this->modified_by = ''; 
      $this->obligation='';

    }
    
  }
  
?>