<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  class cEmployee {
    var $loaded;
    var $employeeK;
    var $departmentFK;
    var $siteFK;
    var $firstname;
    var $lastname;
    var $address_one;
    var $address_two;
    var $city;
    var $postcode;
    var $stateFK;
    var $phone_one;
    var $phone_two;
    var $phone_mobile;
    var $active;
    var $modified_date;
    var $modified_by;
    var $CostCentreFK;
    
    function cEmployee() {
      $this->reset();
    }
    
    function fromArray($array) {
      while(list($key, $val) = each($array)) {
        $this->$key = $val;
      }
    }
    
    function loadById($id) {
      $sql  = 'select e.* ';
      $sql .= 'from tblEmployee e ';
      $sql .= 'where e.employeeK = \''.dbEscapeString($id).'\' ';
      $sql .= 'limit 0,1';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          dbFreeResult($res);
          array_map_to_this($row, $this);
          $this->loaded = true;
        }
      }
    }
    
    function save() {
      $this->loadFromPosted();
      if($this->employeeK == 0) {
        // insert
        $sql  = 'insert into tblEmployee ';
        $sql .= '(departmentFK, siteFK, firstname, lastname, address_one, address_two, ';
        $sql .= ' city, postcode, stateFK, phone_one, phone_two, phone_mobile, active, ';
        $sql .= ' modified_date, modified_by, CostCentreFK) ';
        $sql .= 'values ( ';
        $sql .= '  \''.dbEscapeString($this->departmentFK).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->siteFK).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->firstname).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->lastname).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->address_one).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->address_two).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->city).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->postcode).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->stateFK).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->phone_one).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->phone_two).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->phone_mobile).'\' ';
        $sql .= ' ,\''.($this->active?1:0).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->modified_date).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->modified_by).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->CostCentreFK).'\' ';
        $sql .= ') ';
        $res = dbQuery($sql);
        if(!$res) {
          debug(dbError($sql));
        } else {
          $this->employeeK = dbInsertId();
        }
      } else {
        // update
        $sql  = 'update tblEmployee ';
        $sql .= 'set ';
        $sql .= '  departmentFK = \''.dbEscapeString($this->departmentFK).'\' ';
        $sql .= ' ,siteFK = \''.dbEscapeString($this->siteFK).'\' ';
        $sql .= ' ,firstname = \''.dbEscapeString($this->firstname).'\' ';
        $sql .= ' ,lastname = \''.dbEscapeString($this->lastname).'\' ';
        $sql .= ' ,address_one = \''.dbEscapeString($this->address_one).'\' ';
        $sql .= ' ,address_two = \''.dbEscapeString($this->address_two).'\' ';
        $sql .= ' ,city = \''.dbEscapeString($this->city).'\' ';
        $sql .= ' ,postcode = \''.dbEscapeString($this->postcode).'\' ';
        $sql .= ' ,stateFK = \''.dbEscapeString($this->stateFK).'\' ';
        $sql .= ' ,phone_one = \''.dbEscapeString($this->phone_one).'\' ';
        $sql .= ' ,phone_two = \''.dbEscapeString($this->phone_two).'\' ';
        $sql .= ' ,phone_mobile = \''.dbEscapeString($this->phone_mobile).'\' ';
        $sql .= ' ,active = \''.dbEscapeString($this->active).'\' ';
        $sql .= ' ,modified_date = \''.dbEscapeString($this->modified_date).'\' ';
        $sql .= ' ,modified_by = \''.dbEscapeString($this->modified_by).'\' ';
        $sql .= ' ,CostCentreFK = \''.dbEscapeString($this->CostCentreFK).'\' ';
        $sql .= 'where employeeK = \''.dbEscapeString($this->employeeK).'\' ';
        $res = dbQuery($sql);
        if(!$res) {
          debug(dbError($sql));
        }
      }
      return $this->employeeK;
    }
    
    function validate() {
      global $invalidFields;
      $invalid = array();
      
      
      if($this->departmentFK == 0) {
        $invalid['departmentFK'] = "Please select a department";
      }
      if($this->siteFK == 0) {
        $invalid['siteFK'] = "Please select a location";
      }
      
      if($this->CostCentreFK == 0) {
        $invalid['CostCentreFK'] = "Please select a Cost Centre for this employee";
      }
      
      
      if(strlen(trim($this->firstname)) == 0) {
        $invalid['firstname'] = "Please enter the employees first name";
      }else{
      	if(strlen(trim($this->firstname))>100){
      		$invalid['firstname'] = 'The First Name can be no longer than 100 characters in length';
      	}
      }
      
      if(strlen(trim($this->lastname)) == 0) {
        $invalid['lastname'] = "Please enter the employees last name";
      }else{
      	if(strlen(trim($this->lastname))>100){
      		$invalid['lastname'] = 'The Last Name can be no longer than 100 characters in length';
			}
      }
      
      if(strlen(trim($this->address_one)) == 0) {
        $invalid['address_one'] = "Please enter the employee address";
      }else{
      	if(strlen(trim($this->address_one))>200){
      		$invalid['address_one'] = 'The First line of the Address can be no longer than 200 characters in length';
      	}
      }
      
		if(strlen(trim($this->address_two))>0){
			if(strlen(trim($this->address_two))>200){
				$invalid['address_two'] = 'The Second line of the Address can be no longer than 200 charcters in length';
			}
		}      
      
      if(strlen(trim($this->city)) == 0) {
        $invalid['city'] = "Please enter the employees city";
      }else{
      	if(strlen(trim($this->city))>100){
      		$invalid['city'] = 'The City name can be no longer than 100 characters in length';
      	}
      }
      if($this->stateFK == 0) {
        $invalid['stateFK'] = "Please select a state for this employee";
      }
      if(strlen(trim($this->postcode)) == 0) {
        $invalid['postcode'] = "Please enter the employees postcode";
      }else{
      	if(strlen(trim($this->postcode))>5){
      		$invalid['postcode'] = 'The Post Code can be no longer than 5 characters in length';
      	}
		}
      if(strlen(trim($this->phone_one)) == 0 && strlen(trim($this->phone_two)) == 0 && strlen(trim($this->phone_mobile)) == 0) {
        $invalid['phone_one'] = "Please enter a telephone contact";
      }else{
      	if(strlen(trim($this->phone_one)) >60){
      		$invalid['phone_one'] = 'The First phone number can be no longer than 60 characters in length';
			}
		}
		
		if(strlen(trim($this->phone_two))>0){
			if(strlen(trim($this->phone_two))>60){
				$invalid['phone_two'] = 'The Second Phone number can be no longer than 60 characters in length';
			}
		} 
		
		if(strlen(trim($this->phone_mobile))>0){
			if(strlen(trim($this->phone_mobile))>60){
				$invalid['phone_mobile'] = 'The Second line of the Address can be no longer than 60 charcters in length';
			}
		} 
		      
		
      if(count($invalid) > 0) {
      	if(count($invalidFields)==0){
        	$invalidFields = $invalid; 
      	} else {
      		$invalidFields = array_merge($invalidFields, $invalid);
      	}
        return false;
      }
      return true;
    }
    
    function loadFromPosted() {
      global $sess, $p;
      $this->employeeK = (isset($p->employeeK) ? $p->employeeK : 0);
      $this->departmentFK = (isset($p->departmentFK) ? $p->departmentFK : 0);
      $this->siteFK = (isset($p->siteFK) ? $p->siteFK : 0);
      $this->firstname = (isset($p->firstname) ? $p->firstname : '');
      $this->lastname = (isset($p->lastname) ? $p->lastname : '');
      $this->address_one = (isset($p->address_one) ? $p->address_one : '');
      $this->address_two = (isset($p->address_two) ? $p->address_two : '');
      $this->city = (isset($p->city) ? $p->city : '');
      $this->postcode = (isset($p->postcode) ? $p->postcode : '');
      $this->stateFK = (isset($p->stateFK) ? $p->stateFK : 0);
      $this->phone_one = (isset($p->phone_one) ? $p->phone_one : '');
      $this->phone_two = (isset($p->phone_two) ? $p->phone_two : '');
      $this->phone_mobile = (isset($p->phone_mobile) ? $p->phone_mobile : '');
      $this->active = (isset($p->active) ? $p->active : 0);
      $this->modified_date = ts();
      $this->modified_by = $sess->get('username');
      $this->CostCentreFK = (isset($p->CostCentreFK) ? $p->CostCentreFK : 0);
      
    }
    
    function reset() {
      $this->loaded = false;
      $this->employeeK = 0;
      $this->departmentFK = 0;
      $this->siteFK = 0;
      $this->firstname = '';
      $this->lastname = '';
      $this->address_one = '';
      $this->address_two = '';
      $this->city = '';
      $this->postcode = '';
      $this->stateFK = 0;
      $this->phone_one = '';
      $this->phone_two = '';
      $this->phone_mobile = '';
      $this->active = 0;
      $this->modified_date = '';
      $this->modified_by = '';
      $this->CostCentreFK = 0;
    }
  }

?>