<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  class cFBT {
	 var $fbtK;
	 var $vehicleFK;
	 var $employeeFK;
	 var $fbt_value;
	 var $date_commenced;
	 var $date_concluded;
	 var $private_kms;
	 var $private_days;
	 var $stat_percent;
	 var $modified_date;
	 var $modified_by;  
  
    function cFBT($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    
		$sql = 'select * from tblFBT WHERE fbtK=\''.dbEscapeString($id).'\'';
      
		$res = dbQuery($sql);
		if(!$res) {
			debug(dbError($sql));
		} else {
			if(dbNumRows($res) > 0) {
				$row = dbFetchAssoc($res);
          
				array_map_to_this($row, $this);
			} else {
				$this->reset();
			}
			dbFreeResult($res);
		}
    }

    
    function loadPosted() {
    	global $p;
		
		$this->fbtK = (isset($p->fbtK) ? $p->fbtK : 0);
	 	$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : 0);
	 	$this->employeeFK = (isset($p->employeeFK) ? $p->employeeFK : '');
	 	$this->fbt_value = (isset($p->fbt_value) ? $p->fbt_value : '');
	 	$this->date_commenced = (isset($p->date_commenced) ? $p->date_commenced : 0);
	 	$this->date_concluded = (isset($p->date_concluded) ? $p->date_concluded : '');	 		 	
	 	$this->private_kms = (isset($p->private_kms) ? $p->private_kms : '');
	 	$this->private_days = (isset($p->private_days) ? $p->private_days : '');
	 	$this->stat_percent = (isset($p->stat_percent) ? $p->stat_percent : '');
	 	$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '' );
	 	$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');      	
    	
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();
      
		if($this->vehicleFK==0){
			$invalid['vehicleFK'] = 'No Vehicle was supplied.  Registration details must be attached to a valid Vehicle';
		}  
		
		if($this->employeeFK==0){
			$invalid['employeeFK'] = 'Please select an employee.';
		}  

		if($this->fbt_value==0){
			$invalid['fbt_value'] = 'Please enter an FBT value.';
		}  

		if($this->date_commenced==0){
			$invalid['date_commenced'] = 'Please select a Commencement Date.';
		}
		if($this->fbtK){
			if($this->date_concluded==0){
				$invalid['date_concluded'] = 'Please select a Conclusion Date.';
			}
		}
		
		if($this->private_days==0){
			$invalid['private_days'] = 'Please enter the Private Days.';
		}
 
		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
	 	$this->fbtK=0;
	 	$this->vehicleFK=0;
	 	$this->employeeFK=0;
	 	$this->fbt_value='';
	 	$this->date_commenced='';
	 	$this->date_concluded='';
	 	$this->private_days=0;
	 	$this->modified_date='';
	 	$this->modified_by=0; 
    }
    
  }
  
?>