<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cFuel {
	 var $fuelK;
	 var $vehicleFK;
	 var $amount;
	 var $cost;
	 var $card_no;
	 var $fuel_date;
	 var $reference;
	 var $modified_date;
	 var $modified_by;
	 var $odometer;
  
    function cFuel($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
	function loadById($id) {
    	$sql = 'select * from tblFuel WHERE fuelK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
			$row['fuel_date'] = substr($row['fuel_date'],0,10);         
			$row['modified_date'] = substr($row['modified_date'],0,10);
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }

	function loadByVehicleId($id) {
    	$sql = 'select * from tblFuel WHERE vehicleFK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
			$row['fuel_date'] = substr($row['fuel_date'],0,10);         
			$row['modified_date'] = substr($row['modified_date'],0,10);
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
    	global $p;
		
	 	$this->fuelK = (isset($p->fuelK) ? $p->fuelK : '' );
	 	$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '' );
	 	$this->amount = (isset($p->amount) ? $p->amount : '' );
	 	$this->cost = (isset($p->cost) ? $p->cost : '' );
	 	$this->card_no = (isset($p->card_no) ? $p->card_no : '' );
		if($this->card_no==-2){
			$this->card_no = $p->card_no_text;
		}	 	
	 	
	 	$this->fuel_date = (isset($p->fuel_date) ? $p->fuel_date : '' );
	 	$this->reference = (isset($p->reference) ? $p->reference : '' );
	 	$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '' );
	 	$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
	 	$this->odometer = (isset($p->odometer) ? $p->odometer : '');      	

    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();    
		
		if(strlen(trim($this->amount))==0){
			$invalid['amount'] = 'Please enter the Fuel Amount';
		} else if(strlen($this->amount) > 45) {
			$invalid['amount'] = "Fuel Amount of seats exeeds the maximum field length";
		}

		if(strlen(trim($this->cost)) == 0){
			$invalid['cost'] = 'Please enter the Fuel Cost';
		} else if(strlen($this->cost) > 14) {
			$invalid['cost'] = "Cost price exeeds the maximum field length";
		}else{
			if(!is_numeric($this->cost)){
				$invalid['cost'] = 'Please enter a valid Numeric value for the Fuel Cost';
			}
		}	
		
		if(strlen(trim($this->card_no)) == 0){
			$invalid['card_no'] = 'Please enter a Card No.';
		}

		if(strlen(trim($this->odometer))==0){
			$invalid['odometer'] = 'Please enter the Odometer Reading';
		}else{
			if(!is_numeric($this->odometer)){
				$invalid['odometer'] = 'Please enter a Valid Numeric Entry for Odometer';
			}
		}
		      
      if(count($invalid) > 0) {
        $invalidFields = array_merge($invalidFields, $invalid);
        return false;
      }
      
      
      return true;
    }
    
    function reset() {
	 	$this->fuelK=0;
	 	$this->vehicleFK=0;
	 	$this->amount=0;
	 	$this->cost=0;
	 	$this->card_no=0;
	 	$this->fuel_date='';
	 	$this->reference='';
	 	$this->modified_date='';
	 	$this->modified_by=0; 
	 	$this->odometer = 0;
    }
    
  }
  
?>