<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*@author Daniel
*/
  
  class cIncident {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
  		var $incidentK;
		var $vehicleFK;
		var $employeeFK;
		var $date_time;
		var $location;
		var $reference;
		var $modified_date;
		var $modified_by;


    function cIncident($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblIncident WHERE tblIncident.incidentK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);
		  $row['date_time'] = substr($row['date_time'],0,10);

          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    

    	//load the class variables from the posted values
    	$this->incidentK = (isset($p->incidentK) ? $p->incidentK : '');
		$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '');
		$this->employeeFK = (isset($p->employeeFK) ? $p->employeeFK : '');
		$this->date_time = (isset($p->date_time) ? $p->date_time : '');
		$this->location = (isset($p->location) ? $p->location : '');
		$this->reference = (isset($p->reference) ? $p->reference : '');
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
		$this->damage_details = (isset($p->damage_details) ? $p->damage_details : '');
      $acc_Time_hours =(isset($p->time_date_hours) ? $p->time_date_hours : '');
      $acc_Time_minutes =(isset($p->time_date_minutes) ? $p->time_date_minutes : '');
      $acc_Time_ap =(isset($p->time_date_ap) ? $p->time_date_ap : '');
      
      $this->date_time = $this->date_time.' '.$acc_Time_hours.':'.$acc_Time_minutes.':00 '.$acc_Time_ap;
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		if($this->incidentK != 0){
			$sql = 'SELECT COUNT(*) as lCount FROM tblIncident WHERE incidentK='. dbEscapeString($this->incidentK);
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount']==0){
						$invalid['incidentK'] = 'The Selected Accident could not be found';
					}
				}
				dbFreeResult($res);
			}
		}  

		if($this->vehicleFK == 0){
			$invalid['vehicleFK'] = 'Please enter a valid Vehicle ID';
		} 

		

		if($this->employeeFK == 0){
			$invalid['employeeFK'] = "Please select an Employee";
		} 

		if(strlen($this->reference) > 60) {
			$invalid['reference'] = "Reference number exeeds the maximum field length";
		} 

		if(strlen(trim($this->date_time)) == 0){
			$invalid['date_time'] = 'Please select a Date';
		} 
		
				
		
		if(strlen(trim($this->location)) == ''){
			$invalid['location'] = 'Please enter a Location';
		} else if(strlen($this->location) > 200) {
			$invalid['location'] = "Location exeeds the maximum field length";
		}

		

		if(strlen(trim($this->damage_details))==0){
			$invalid['damage_details']='Please enter the details of any Damage Sustained';
		}else{
			if(strlen(trim($this->damage_details))>255){
				$invalid['damage_details'] = 'The Damage details can contain no more than 255 characters';
			}
		}

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->incidentK = 0;
      $this->vehicleFK = 0;
      $this->employeeFK = 0;
      $this->date_time = '';
      $this->location = '';
      $this->reference = '';
      $this->modified_date = '';
      $this->modified_by = '';
      $this->damage_details = '';

    }
    
  }
  
?>