<?php
  /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
* @author Daniel
*/
  
  class cInfringement {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
  		var $infringementK;
  		var $vehicleFK;
  		var $employeeFK;
  		var $number;
  		var $date_time;
  		var $cost;
  		var $description;
  		var $modified_date;
  		var $modified_by; 
		var $obligation;
    
    function cInfringement($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblInfringement WHERE tblInfringement.infringementK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);
		   $row['date_time'] = substr($row['date_time'],0,10);

          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    
    
    	//load the class variables from the posted values
    	$this->infringementK = (isset($p->infringementK) ? $p->infringementK : '');
		$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '');
		$this->employeeFK = (isset($p->employeeFK) ? $p->employeeFK : '');
		$this->number = (isset($p->number) ? $p->number : '');
		$this->date_time = (isset($p->date_time) ? $p->date_time : '');
		$this->cost = (isset($p->cost) ? $p->cost : '');
		$this->description = (isset($p->description) ? $p->description : '');
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
		$this->obligation = (isset($p->obligation) ? $p->obligation : '');

      //example for loading a date
      if(isset($p->year) && isset($p->month) && isset($p->day)) {
        $date = $p->year."-".str_pad($p->month, 2, '0', STR_PAD_LEFT)."-".str_pad($p->day, 2, '0', STR_PAD_LEFT);
      } else if(isset($p->date_obtained) && strlen($p->date_obtained) > 0) {
        $date = $p->date_obtained;
      } else {
        $date = '';
      }
      $this->dateField = $date;
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		if($this->infringementK != 0){
			$sql = 'SELECT COUNT(*) as lCount FROM tblInfringement WHERE infringementK='. dbEscapeString($this->infringementK);
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount']==0){
						$invalid['infringementK'] = 'The Selected Infringement could not be found';
					}
				}
				dbFreeResult($res);
			}
		}  

		if($this->vehicleFK == 0){
			$invalid['vehicleFK'] = 'Please enter a valid Vehicle ID';
		}

		if($this->employeeFK == 0){
			$invalid['employeeFK'] = 'Please select an Employee';
		}

		if(strlen(trim($this->number)) == ''){
			$invalid['number'] = 'Please enter a Number';
		} else if(strlen($this->number) > 60) {
			$invalid['number'] = "Number exeeds the maximum field length";
		}

		if(strlen(trim($this->date_time)) == 0) {
			$invalid['date_time'] = 'Please select a Date';
		}

		if(strlen(trim($this->cost)) == 0){
			$invalid['cost'] = 'Please enter the Cost of Infringement';
		}elseif(!is_numeric($this->cost)){
			$invalid['cost'] = 'Please enter a valid price value for the Infringement Cost';
		} else if(strlen($this->cost) > 14) {
			$invalid['cost'] = "Cost price exeeds the maximum field length";
		}

		if(strlen(trim($this->description)) == ''){
			$invalid['description'] = 'Please enter a Description';
		}

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->infringementK = 0;
      $this->vehicleFK = 0;
      $this->employeeFK = 0;
      $this->number = '';
      $this->date_time = '';
      $this->cost = '';
      $this->description = '';
      $this->modified_date = '';
      $this->modified_by = '';

    }
    
  }
  
?>