<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cService {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
  		var $serviceK;
  		var $description;  		
		var $cost;
  		var $modified_date;  		
		var $modified_by;
  		var $serviceRepairFK;  		
		var $nextServiceOdometerReading;
  		var $nextServiceDate;  		
  		
    
    function cService($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape string in supplied $id
		$sql = 'SELECT * FROM tblService WHERE tblService.serviceK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
		return false;
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);
		  $row['nextServiceDate'] = substr($row['nextServiceDate'],0,10);
          array_map_to_this($row, $this);
		  return true;
        } else {
          $this->reset();
		  return false;
        }
        dbFreeResult($res);
      }
    }
	
	function loadByAppointmentId($id){
		//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape string in supplied $id
		$sql = 'SELECT * FROM tblService WHERE tblService.serviceRepairFK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
		return false;
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);
		  $row['nextServiceDate'] = substr($row['nextServiceDate'],0,10);
          array_map_to_this($row, $this);
		  return true;
        } else {
          $this->reset();
		  return false;
        }
        dbFreeResult($res);
      }
	}
	    function loadByVehicleId($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblService WHERE tblService.vehicleFK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        dbError($sql);
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);
		  $row['nextServiceDate'] = substr($row['nextServiceDate'],0,10);
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    
    
    	//load the class variables from the posted values
    	$this->serviceK = (isset($p->serviceK) ? $p->serviceK : '');
    	$this->description = (isset($p->description) ? $p->description : '');
		$this->cost = (isset($p->cost) ? $p->cost : '');
    	$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
    	$this->serviceRepairFK = (isset($p->serviceRepairFK) ? $p->serviceRepairFK : '');
		$this->nextServiceOdometerReading = (isset($p->nextServiceOdometerReading) ? $p->nextServiceOdometerReading : '');
    	$this->nextServiceDate = (isset($p->nextServiceDate) ? $p->nextServiceDate : ''); 
      
      //example for loading a date
      if(isset($p->year) && isset($p->month) && isset($p->day)) {
        $date = $p->year."-".str_pad($p->month, 2, '0', STR_PAD_LEFT)."-".str_pad($p->day, 2, '0', STR_PAD_LEFT);
      } else if(isset($p->date_obtained) && strlen($p->date_obtained) > 0) {
        $date = $p->date_obtained;
      } else {
        $date = '';
      }
      $this->dateField = $date;
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		//example for validation
		if(strlen(trim($this->description))== ''){
			$invalid['description'] = 'Please enter a Description';
		}

		if(strlen(trim($this->cost)) == 0){
			$invalid['cost'] = 'Please enter the Cost of the Service';
		}elseif(!is_numeric($this->cost)){
				$invalid['cost'] = 'Please enter a valid Price value for the Service Cost';
		}

		if(strlen(trim($this->nextServiceOdometerReading)) == 0){
			$invalid['nextServiceOdometerReading'] = 'Please enter a Odometer Reading for the Next Service';
		}else{
			if(!is_numeric($this->nextServiceOdometerReading)){
				$invalid['nextServiceOdometerReading'] = 'Please enter a valid numeric Odometre reading';
			}
		}
		
		if(strlen(trim($this->nextServiceDate)) == 0){
			$invalid['nextServiceDate'] = 'Please enter a Date for the Next Service';
		}  

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->serviceK = 0;
      $this->description = ''; 		
      $this->cost = 0;
      $this->modified_date = ''; 		
      $this->modified_by = 0;
      $this->serviceRepairFK = 0;  		
      $this->nextServiceOdometerReading = '';
      $this->nextServiceDate = '';
    }
    
  }
  
?>