<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*@author Daniel
*/
  
  class cServiceRepairs {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
  		var $servicerepairsPK;
  		var $vehicleFK;  
		var $appointmentDate;  
		var $actualDate;  
		var $expectedReturnDate;  
		var $agentFK;  
		var $odometerReading;  
		var $comments;  
		var $modified_by;  
		var $modified_date;  
  		
    
    function cServiceRepairs($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblServiceRepairs WHERE tblServiceRepairs.servicerepairsPK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['appointmentDate'] = substr($row['appointmentDate'],0,10);
		  $row['actualDate'] = substr($row['actualDate'],0,10);
		  $row['expectedReturnDate'] = substr($row['expectedReturnDate'],0,10);

          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }

	function loadByVehicle($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblServiceRepairs WHERE tblServiceRepairs.vehicleFK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['appointmentDate'] = substr($row['appointmentDate'],0,10);
		  $row['actualDate'] = substr($row['actualDate'],0,10);
		  $row['expectedReturnDate'] = substr($row['expectedReturnDate'],0,10);

          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    

    	//load the class variables from the posted values
    	$this->servicerepairsPK = (isset($p->servicerepairsPK) ? $p->servicerepairsPK : '');
    	$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '');
		$this->appointmentDate = (isset($p->appointmentDate) ? $p->appointmentDate : '');

		if($this->servicerepairsPK==0) {
			$this->actualDate = $this->appointmentDate;
		} else {
			$this->actualDate = (isset($p->actualDate) ? $p->actualDate : '');
		}
		$this->expectedReturnDate = (isset($p->expectedReturnDate) ? $p->expectedReturnDate : '');
		$this->agentFK = (isset($p->agentFK) ? $p->agentFK : '');
		$this->odometerReading = (isset($p->odometerReading) ? $p->odometerReading : '');
		$this->comments = (isset($p->comments) ? $p->comments : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');      
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		//example for validation		
		if($this->vehicleFK == 0){
			$invalid['vehicleFK'] = 'Please enter a valid Vehicle ID';
		}

		if($this->agentFK == 0){
			$invalid['agentFK'] = 'Please select an Agent';
		}

		if(strlen(trim($this->appointmentDate)) == 0){
			$invalid['appointmentDate'] = 'Please enter a valid value for appointmentDate';
		} else{
			if(strlen(trim($this->expectedReturnDate)) != 0 && $this->expectedReturnDate < $this->appointmentDate){
				$invalid['appointmentDate'] = 'Appointment Date is after the Expected Return Date';
			}
		} 
		
		if((strlen(trim($this->actualDate)==0)) && ($this->servicerepairsPK != 0)) {
			$invalid['actualDate'] = 'Please enter a valid value for actual Date';
		} 

		if(strlen(trim($this->expectedReturnDate)) == 0){
			$invalid['expectedReturnDate'] = 'Please enter a valid value for expectedReturnDate';
		} 

		if(strlen(trim($this->expectedReturnDate)) == 0){
			$invalid['expectedReturnDate'] = 'Please enter an Expected Return Date';
		} else{
			if(strlen(trim($this->appointmentDate)) != 0 && $this->appointmentDate > $this->expectedReturnDate){
				$invalid['expectedReturnDate'] = 'Expected Return Date is before the Appointment Date';
			}
		} 

		if(strlen(trim($this->odometerReading)) == 0){
			$invalid['odometerReading'] = 'Please enter an Odometer Reading';
		} else{
			if(!is_numeric($this->odometerReading)) {
				$invalid['odometerReading'] = 'Odometer Reading is not a number';
			}
		} 

		if(strlen(trim($this->comments)) == ''){
			$invalid['comments'] = 'Please enter in the Comments';
		} 

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->servicerepairsPK = 0;
      $this->vehicleFK = 0;  
      $this->appointmentDate = '';  
      $this->actualDate = '';
	  $this->expectedReturnDate = '';
      $this->agentFK = 0;  
      $this->odometerReading = '';  
      $this->comments = '';  
      $this->modified_by = 0;  
      $this->modified_date = '';  
    }
    
  }
  
?>