<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  class cUser {
    var $userK;
    var $username;
    var $pass;
    var $v_pass;
    var $accessFK;
    var $employeeFK;
    var $lastlogin;
    var $lastlogin_ip;
    var $email;
    var $modified_date;
    var $modified_by;
    var $notify;
    var $monthlyreports;
    
    function cUser() {
      $this->reset();
    }
    
    function fromArray($array) {
      while(list($key, $val) = each($array)) {
        $this->$key = $val;
      }
    }
    
    function save($employeeK=0) {
      global $sess;
      $this->loadFromPosted();
      $this->modified_date = ts();
      $this->modified_by = $sess->userK;
      if($this->userK == 0) {
        // insert
        $sql  = 'insert into tblUser ';
        $sql .= '(accessFK, employeeFK, username, pass, email, ';
        $sql .= ' modified_date, modified_by, notify, monthlyreports) ';
        $sql .= 'values ( ';
        $sql .= '  \''.dbEscapeString($this->accessFK).'\' ';
        if($this->employeeFK == 0) {
          $sql .= ' ,\''.dbEscapeString($employeeK).'\' ';
        } else {
          $sql .= ' ,\''.dbEscapeString($this->employeeFK).'\' ';
        }
        $sql .= ' ,\''.dbEscapeString($this->username).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->pass).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->email).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->modified_date).'\' ';
        $sql .= ' ,\''.dbEscapeString($this->modified_by).'\' ';
        $sql .= ' ,\''.($this->notify?1:0).'\' ';
        $sql .= ' ,\''.($this->monthlyreports?1:0).'\' ';
        $sql .= ') ';
        $res = dbQuery($sql);
        if(!$res) {
          debug(dbError($sql));
        } else {
          $this->userK = dbInsertId();
        }
      } else {
        // update
        $sql  = 'update tblUser ';
        $sql .= 'set ';
        $sql .= '  accessFK = \''.dbEscapeString($this->accessFK).'\' ';
        if($this->employeeFK == 0) {
          $sql .= ' ,employeeFK = \''.dbEscapeString($employeeK).'\' ';
        } else {
          $sql .= ' ,employeeFK = \''.dbEscapeString($this->employeeFK).'\' ';
        }
        $sql .= ' ,username = \''.dbEscapeString($this->username).'\' ';
        if(strlen(trim($this->pass)) > 0) {
          $sql .= ' ,pass = \''.dbEscapeString($this->pass).'\' ';
        }
        $sql .= ' ,email = \''.dbEscapeString($this->email).'\' ';
        $sql .= ' ,notify = \''.($this->notify?1:0).'\' ';
        $sql .= ' ,monthlyreports = \''.($this->monthlyreports?1:0).'\' ';
        $sql .= ' ,modified_date = \''.dbEscapeString($this->modified_date).'\' ';
        $sql .= ' ,modified_by = \''.dbEscapeString($this->modified_by).'\' ';
        $sql .= 'where userK = \''.dbEscapeString($this->userK).'\' ';
        $res = dbQuery($sql);
        if(!$res) {
          debug(dbError($sql));
        }
      }
      return $this->userK;
    }
    
    function loadById($id) {
      $sql  = 'select u.*, ';
      $sql .= '       a.level as access, unix_timestamp(lastlogin) as lastlogin_ts ';
      $sql .= 'from tblUser u ';
      $sql .= 'inner join tblAccess a on (a.accessK = u.accessFK) ';
      $sql .= 'where u.userK = \''.dbEscapeString($id).'\' ';
      $sql .= 'limit 0,1';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          dbFreeResult($res);
          array_map_to_this($row, $this);
        }
      }
    }
    
    function loadByEmployeeId($employeeK) {
      $sql  = 'select u.*, ';
      $sql .= '       a.level as access, unix_timestamp(lastlogin) as lastlogin_ts ';
      $sql .= 'from tblUser u ';
      $sql .= 'inner join tblAccess a on (a.accessK = u.accessFK) ';
      $sql .= 'where u.employeeFK = \''.dbEscapeString($employeeK).'\' ';
      $sql .= 'limit 0,1';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          dbFreeResult($res);
          array_map_to_this($row, $this);
        }
      }
    }
    
    function loadFromPosted() {
      global $p;
      $this->userK = (isset($p->userK) ? $p->userK : 0);
      $this->username = (isset($p->username) ? $p->username : '');
      $this->pass = (isset($p->pass) ? $p->pass : '');
      $this->v_pass = (isset($p->v_pass) ? $p->v_pass : '');
      $this->accessFK = (isset($p->accessFK) ? $p->accessFK : 0);
      $this->lastlogin = (isset($p->lastlogin) ? $p->lastlogin : '');
      $this->lastlogin_ip = (isset($p->lastlogin_ip) ? $p->lastlogin_ip : '');
      $this->email = (isset($p->email) ? $p->email : '');
      $this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
      $this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
      $this->notify = (isset($p->notify) ? $p->notify : false);
      $this->monthlyreports = (isset($p->monthlyreports) ? $p->monthlyreports : false);
    }
    
    function validate() {
      global $invalidFields;
      $invalid = array();
      if(strlen(trim($this->username)) == 0) {
        $invalid['username'] = "Please enter a valid user name";
      }else{
      	if(strlen(trim($this->username))>45){
      		$invalid['username'] = 'The username can be no longer than 45 characters in length';
			}
      	
      	$sql = 'SELECT COUNT(*) as lCount FROM tblUser WHERE username="'.$this->username.'"';
      	if(isset($this->userK)){
      		$sql .= ' AND userK<>'.$this->userK;
      	}
      	
      	$res = dbQuery($sql);
      	
      	if(!$res){
      		debug(dbError($sql));
      	}else{
      		$item = dbFetchAssoc($res);
      		
      		if(!$item){
      			debug(dbError($sql));
				}else{
					if($item['lCount']>0){
						$invalid['username'] = 'The Username entered already Exists';
					}
				}
				dbFreeResult($res);
      	}
      }
      if($this->employeeFK == 0) {
        if(strlen(trim($this->pass)) == 0) {
          $invalid['pass'] = "Please enter a valid password";
        } else if($this->v_pass != $this->pass) {
          $invalid['pass'] = "Passwords do not match";
          $invalid['v_pass'] = '';
        }else{
        	if(strlen(trim($this->pass))>45){
        		$invalid['pass'] = 'The password can be no longer than 45 characters in length';
        		$invalid['v_pass']='';
        	}
        }
      } else {
        if(strlen(trim($this->pass)) == 0 && $this->pass != $this->v_pass) {
          $invalid['pass'] = "Passwords do not match";
          $invalid['v_pass'] = '';
        }
		if(strlen(trim($this->v_pass)) == 0) {
          $invalid['v_pass'] = 'Please enter a valid password';
        }
      }
      if(strlen(trim($this->email)) == 0) {
        $invalid['email'] = "Please enter an email address for this user";
      }else{
      	if(strlen(trim($this->email))>255){
      		$invalid['email'] = 'The Email can be no longer than 255 characters in length';
      	}
      }
      if($this->accessFK == 0) {
        $invalid['accessFK'] = "Please select a valid access level for this user";
      }
      
      
      if(count($invalid) > 0) {
        if(is_array($invalidFields)){
	        $invalidFields = array_merge($invalidFields, $invalid);
	} else {
		$invalidFields = $invalid;
	}
        return false;
      }
      return true;
    }
    
    function reset() {
      $this->userK = 0;
      $this->username = '';
      $this->pass = '';
      $this->v_pass = '';
      $this->accessFK = '';
      $this->employeeFK = 0;
      $this->lastlogin = '';
      $this->lastlogin_ip = '';
      $this->email = '';
      $this->modified_date = '';
      $this->modified_by = 0;
    }
    
  }

?>