<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*@author Gef <gef@internode.on.net>
*/

  $dbConnected=false;
  $numQueries = 0;
  $queryMSecs = 0;
  $sqlHistory = array();
  $errorDetails = array();

  /**
  * @return unknown
  * @desc open connection to database
  */
  function dbConnect($errorAsString=false) {
    global $dbConnected, $conf;
    $hostname = DATABASE_HOST;
    $database = DATABASE_NAME;
    $username = DATABASE_USER;
    $password = DATABASE_PASS;
    if($dbConnected) {
      return true;
    }

    if(!@mysql_pconnect($hostname, $username, $password)) {
      global $errorDetails;
      $errData = $errorAsString ? dbErrorToString() : dbError($sql,true);
      $errorDetails[] = array(array('file'=>__FILE__,'line'=>__LINE__,'function'=>__FUNCTION__, 'data'=>$errData), 'dbConnect::pconnect');
      return false;
    }
    
    if(!@mysql_select_db($database)) {
    	global $errorDetails;
    	$errData = $errorAsString ? dbErrorToString() : dbError($sql,true);
    	
      $errorDetails[] = array(array('file'=>__FILE__,'line'=>__LINE__,'function'=>__FUNCTION__, 'data'=>$errData), 'dbConnect::selectdb');
      return false;
    }
    $dbConnected = true;
    return true;
  }

  function dbFormatSQLHistory() {
    global $sqlHistory;
    if(!is_array($sqlHistory)) {
      return;
    }
    $ob = ob_get_contents();
    ob_clean();
    ?>
      <style type='text/css'>
        table tr.SQLdebugOdd  { background: #fff; }
        table tr.SQLdebugEven { background: #eee; }
        table.SQLdebugTable td { font-family: Arial; font-size: 11px; }
      </style>
      <table cellpadding='2' cellspacing='1' border='0' width='100%' style='background:#444;' class='SQLdebugTable'>
      <tr>
        <td style='background-color: white;'><b>#</b></td>
        <td style='background-color: white;'><b>Time</b></td>
        <td style='background-color: white;'><b>SQL Query History</b></td>
      </tr>
      <? foreach($sqlHistory as $idx=>$val) { ?>
      <tr class='SQLdebug<?php echo ($idx % 2) ? 'Odd' : 'Even';?>'>
        <td valign='top'><?php echo $idx;?>.</td>
        <td valign='top'><?=number_format(round($val[0],4),4);?>s</td>
        <td valign='top'><tt style='font-size: 9px;'><?php echo $val[1];?></tt></td>
      </tr>
      <? } ?>
      </table>
    <?php
    $out = ob_get_contents();
    ob_clean();
    echo $ob;
    return $out;
  }
  
  function dbError($sql='') {
    $output  = "<div align='center'><div align='left' style='border:1px solid red;background-color: white;padding:4px;margin:3px;'>";
    $output .= "Database Error:<br>";
    if(strlen($sql) > 0) {
      $output .= "<b>SQL: </b>" . $sql . "<br><br>";
    } else {
      $output .= "<b>No SQL included</b><br/>";
    }
    $output .= "<b>mySQL Error: </b>" . mysql_error() . "<br>";
    $output .= "</div></div><br>";
    return $output;
  }
  
  function dbErrorToString(){
    $output .= "Database Error: ". mysql_error();
    return $output;	
  }

  function dbGetHistory() {
    global $sqlHistory;
    return $sqlHistory;
  }
  
  function dbQuery($sql) {
    global $dbConnected, $numQueries, $queryMSecs, $sqlHistory;
    global $resultHistory;

    if(strlen($sql) == 0) {
      return false;
    }
    if($dbConnected == false) {
      dbConnect();
      if($dbConnected == false) {
        return false;
      }
    }
    $timestart = dbTimer();
    $res = mysql_query($sql);
    $timerEnd = dbTimer($timestart);
    $queryMSecs += $timerEnd;
    $sqlHistory[] = array($timerEnd,$sql);
    $numQueries++;
    $resultHistory[] = $res;
    return $res;
  }

  function dbFetchArray($result) {
    if($result) {
      return mysql_fetch_array($result);
    } else {
      return false;
    }
  }
  
  function dbFetchAssoc($result) {
    if($result) {
		if($returnItem = mysql_fetch_assoc($result)){
			$sless = array();
			foreach($returnItem as $key => $value) {
				$sless[$key] = stripslashes($value);
			}
      	return $sless;
      }else{
      	return 0;
      }
    } else {
      return 0;
    }
  }

   function dbFetchLengths($result) {
    if($result) {
      return mysql_fetch_lengths($result);
    } else {
      return 0;
    }
  }

  function dbNumRows($result) {
    if($result) {
      return mysql_num_rows($result);
    } else {
      return 0;
    }
  }
  
  function dbAffectedRows($result) {
    if($result) {
      return mysql_affected_rows();
    } else {
      return 0;
    }
  }
  
  function dbFreeResult($result) {
    if($result) {
      return mysql_free_result($result);
    } else {
      return false;
    }
  }
  
  function dbClosure() {
    global $resultHistory;
    if(is_array($resultHistory)) {
      $size = count($resultHistory);
      $results = array_values($resultHistory);
      for($i = 0; $i < $size; $i++) {
        if($results[$i]) {
          mysql_free_result($results[$i]);
        }
      }
    }
  }
  
  function dbClose() {
    global $dbConnected;
    //dbClosure();
    if($dbConnected) {
      mysql_close();
    }
    return true;
  }
  
  function dbInsertId() {
    return mysql_insert_id(); 
  }

  function dbEscapeString($string) {
    if(strlen($string) > 0 && !is_numeric($string)) {
      return mysql_escape_string($string);
    }
    return $string;
  }
  
  function dbNumQueries() {
    global $numQueries;
    return $numQueries;
  }
  
  function dbTimer($start=0) {
    $time = explode( " ", microtime());
    $usec = (double)$time[0];
    $sec = (double)$time[1];
    if($start != 0) {
      return (($sec + $usec) - $start);
    } else {
      return $sec + $usec;
    }
  }
  
  function dbTimeUsed() {
    return $queryMSecs;
  }
  
  function dbGetFieldNames($table) {
    $fields = array();
    $sql = 'describe `'.dbEscapeString($table).'`;';
    //OR: $sql = 'select * from `'.$table.'` where 0;';
    $res = dbQuery($sql);
    if(!$res) {
      die(dbError($sql));
    } else {
      while($row = dbFetchAssoc($res)) {
        $fields[] = $row['Field'];
      }
      dbFreeResult($res);
    }
    return $fields;
  }

  function dbGetFieldSizes($table) {
    $fields = array();
    $sql = 'describe `'.dbEscapeString($table).'`;';
	//$sql = 'select '.$f.' from `'.$table.'`;';
    $res = dbQuery($sql);
    if(!$res) {
      die(dbError($sql));
    } else {
      while($row = @dbFetchAssoc($res)) {
		$split1 = @explode('(',$row['Type']);
		$split2 = @explode(')',$split1[1]);
		$size = $split2[0];
		if(empty($size) || !is_numeric($size)) {
			$size = '50';
		}
        $fields[$row['Field']] = $size;
      }
      dbFreeResult($res);
    }
    return $fields;
  }
  
  function dbDeletePosted($table, $pk, $value=false) {
    global $p;
    if(isset($p->_values[$pk]) && $p->_values[$pk] != 0) {
      // audit first...
      // delete
      $sql  = 'delete from `'.dbEscapeString($table).'` ';
      $sql .= 'where `'.dbEscapeString($pk).'` = ';
      if($value == false) {
        $sql .= '     \''.dbEscapeString($p->_values[$pk]).'\' ';
      } else {
        $sql .= '     \''.dbEscapeString($value).'\' ';
      }
      $sql .= 'limit 1;';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        return true;
      }
    } else {
      return false;
    }
  }
  
  function dbDeleteRow($table, $pk, $value) {
    $sql  = 'delete from `'.dbEscapeString($table).'` ';
    $sql .= 'where `'.dbEscapeString($pk).'` = ';
    $sql .= '     \''.dbEscapeString($value).'\' ';
    $sql .= 'limit 1;';
    
    $res = dbQuery($sql);
    if(!$res) {
      debug(dbError($sql));
      return false;
    }
    return true;
  }
  
  
  //this function uses the global $_POST array as the field names and values to create an insert or update
  function dbWritePosted($table, $pk, $exclude=false) {
    global $p;
    $insert = ($p->_values[$pk] == 0 || $p->_values[$pk] == false || !isset($p->_values[$pk])) ? true : false;
    $data = array();
    
    $fieldNames = dbGetFieldNames($table);
    
    if(isset($p->_values)) {
		foreach($p->_values as $key=>$val){
      //while(list($key, $val) = each($p->_values)) {
        if(in_array($key, $fieldNames, true) && $key != $pk) {
          if($exclude == false || (is_array($exclude) && !in_array($key, $exclude))) {
            switch($val) {
              case 'now()': $val = $val; break;
              default: $val = '\''.dbEscapeString($val).'\' ';
            }
            
            if($insert) {
              $data[$key] = stripslashes($val);
            } else {
              $data[] = '`'.$key.'` = '.stripslashes(str_replace('\r\n', '<br>', $val));
            }
          }
        }
      }
      
      if($insert) {
        $sql  = 'insert into `'.dbEscapeString($table).'` ';
        $sql .= '('.implode(',', array_keys($data)).') ';
        $sql .= 'values ( ';
        $sql .= implode(',', array_values($data));
        $sql .= ') ';
      } else {
        $sql  = 'update `'.dbEscapeString($table).'` ';
        $sql .= 'set ';
        $sql .= implode(',', $data);
        $sql .= 'where `'.dbEscapeString($pk).'` = \''.dbEscapeString($p->_values[$pk]).'\' ';
        $sql .= 'limit 1';
      }
      
      $res = dbQuery($sql);
      if(!$res) {
        die(dbError($sql));
      } else {
        if($insert) {
          return dbInsertId();
        } else {
          return $p->_values[$pk];
        }
      }
    }
  }
  
  function getFieldValueFromId($tableName, $fieldName, $idFieldName, $idValue){
  		$sql = 'SELECT '.$fieldName.' FROM '.$tableName.' WHERE '.$idFieldName.'='.$idValue;
	
		$res = dbQuery($sql);
	
		if(!$res){
			debug(dbError($sql));
		}else{
			$purpose = dbFetchAssoc($res);
		
			if(!$purpose){
				return false;	
			}else{
				$purposeText = $purpose[$fieldName];
				dbFreeResult($res);
				return $purposeText;
			}
		}
  }
  
  
  function getEmployeeFullName($employeeId){
	$sql = 'SELECT tblEmployee.* FROM  tblEmployee Inner Join tblUser on tblUser.employeeFK = tblEmployee.employeeK WHERE userK='.$employeeId;
	
	$res = dbQuery($sql);
	$fullName = '';
	if(!$res){
		debug(dbError($sql));
	}else{
		$row = dbFetchAssoc($res);
		
		if(strlen(trim($row['firstname']))){
				$fullName = $row['firstname'].' '.$row['lastname'];
		}
		
		dbFreeResult($res);
	}
	
	return $fullName;
}

function getEmployeeFullNameFromAudit($employeeId){
	$sql = 'SELECT * FROM  tblEmployee_Audit WHERE employeeK='.$employeeId.' ORDER BY mdate DESC LIMIT 0,1';
	
	$res = dbQuery($sql);
	$fullName = '';
	if(!$res){
		debug(dbError($sql));
	}else{
		$row = dbFetchAssoc($res);
		
		if(strlen(trim($row['firstname']))){
				$fullName = $row['firstname'].' '.$row['lastname'];
		}
		
		dbFreeResult($res);
	}
	
	return $fullName;
}

function getEmployeeUserName($employeeId){
	$sql = 'SELECT * FROM  tblUser WHERE userK='.$employeeId;
	
	$res = dbQuery($sql);
	$fullName = '';
	if(!$res){
		debug(dbError($sql));
	}else{
		$row = dbFetchAssoc($res);
		$fullName = $row['username'];
		
		dbFreeResult($res);
	}
	
	return $fullName;
}

function getEmployeeUserNameFromAudit($employeeId){
	$sql = 'SELECT * FROM  tblUser_Audit WHERE userK='.$employeeId.' ORDER BY mdate DESC LIMIT 0,1';
	
	$res = dbQuery($sql);
	$fullName = '';
	if(!$res){
		debug(dbError($sql));
	}else{
		$row = dbFetchAssoc($res);
		
		$fullName = $row['username'];
		
		
		dbFreeResult($res);
	}
	
	return $fullName;
}

function getVehicleModelName($modelId){
	$sql = 'SELECT concat(man.name, " ", model.modelname, " - ", ct.typename) as modelName FROM ';
	$sql .= 'tblModel model INNER JOIN tblManufacturer man ON model.manufacturerFK = man.manufacturerK ';
	$sql .= 'INNER JOIN tblCarType ct ON model.carTypeFK = ct.carTypeK ';
	$sql .= 'WHERE modelK = '. $modelId ;

	$res = dbQuery($sql);
	$fullName = '';
	if(!$res){
		debug(dbError($sql));
	}else{
		$row = dbFetchAssoc($res);
		
		$fullName = $row['modelName'];
		
		dbFreeResult($res);
	}
	
	return $fullName;
}

function getVehicleFBTOwner($vehicleId){
	$sql = 'SELECT * FROM tblFBT fbt INNER JOIN tblEmployee emp ON fbt.employeeFK = emp.employeeK WHERE vehicleFK='.$vehicleId.' ORDER BY date_commenced LIMIT 0,1';
	
	$employeeName = '';
	$res = dbQuery($sql);
	if(!$res){
		debug(dbError($sql));
	}else{
		$row = dbFetchAssoc($res);
		
		$employeeName = $row['firstname'].' '.$row['lastname'];
		
		dbFreeResult($res);
	}
	
	return $employeeName;
}
?>
